(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@plus-minus/decorators/mixin-classes', ['exports', 'rxjs'], factory) :
    (global = global || self, factory((global['plus-minus'] = global['plus-minus'] || {}, global['plus-minus'].decorators = global['plus-minus'].decorators || {}, global['plus-minus'].decorators['mixin-classes'] = {}), global.rxjs));
}(this, (function (exports, rxjs) { 'use strict';

    var SubscriptionMixin = /** @class */ (function () {
        function SubscriptionMixin() {
            this.rxSubIds = new rxjs.Subscription();
            this.timeOutSubs = [];
        }
        SubscriptionMixin.prototype.addSubId = function (id) {
            if (id instanceof rxjs.Subscription) {
                this.rxSubIds.add(id);
            }
            else if (Number.isInteger(id)) {
                this.timeOutSubs.push(id);
            }
        };
        SubscriptionMixin.prototype.clearSubById = function (id) {
            if (id instanceof rxjs.Subscription) {
                id.unsubscribe();
                this.rxSubIds.remove(id);
            }
            else if (Number.isInteger(id)) {
                this.timeOutSubs = this.timeOutSubs
                    .filter(function (subId, index) {
                    var isNotRemove = subId !== id;
                    if (!isNotRemove) {
                        clearTimeout(subId);
                    }
                    return isNotRemove;
                });
            }
        };
        SubscriptionMixin.prototype.clearAllSubs = function () {
            this.rxSubIds.unsubscribe();
            this.timeOutSubs.forEach(function (id) { return clearTimeout(id); });
            this.timeOutSubs.splice(0);
        };
        return SubscriptionMixin;
    }());

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SubscriptionMixin = SubscriptionMixin;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=plus-minus-decorators-mixin-classes.umd.js.map
