import { Subscription } from 'rxjs';

class SubscriptionMixin {
    constructor() {
        this.rxSubIds = new Subscription();
        this.timeOutSubs = [];
    }
    addSubId(id) {
        if (id instanceof Subscription) {
            this.rxSubIds.add(id);
        }
        else if (Number.isInteger(id)) {
            this.timeOutSubs.push(id);
        }
    }
    clearSubById(id) {
        if (id instanceof Subscription) {
            id.unsubscribe();
            this.rxSubIds.remove(id);
        }
        else if (Number.isInteger(id)) {
            this.timeOutSubs = this.timeOutSubs
                .filter((subId, index) => {
                const isNotRemove = subId !== id;
                if (!isNotRemove) {
                    clearTimeout(subId);
                }
                return isNotRemove;
            });
        }
    }
    clearAllSubs() {
        this.rxSubIds.unsubscribe();
        this.timeOutSubs.forEach((id) => clearTimeout(id));
        this.timeOutSubs.splice(0);
    }
}

/**
 * Generated bundle index. Do not edit.
 */

export { SubscriptionMixin };
//# sourceMappingURL=plus-minus-decorators-mixin-classes.js.map
